import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.filechooser.FileFilter;
import java.io.*;
import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;
import java.util.*;
import java.awt.image.*;
import java.awt.image.renderable.*;
import javax.media.jai.*;
import javax.media.jai.operator.*;

public class ColorChannelDlg extends JInternalFrame implements ActionListener {
    private JRadioButton m_btnRed;
    private JRadioButton m_btnGreen;
    private JRadioButton m_btnBlue;
    private PicEdit m_frmParent;
    
    public ColorChannelDlg(final PicEdit frmParent) {
        super("Farbkanle...", false, true, false, true);
        this.m_frmParent = frmParent;
        getContentPane().setLayout(new BorderLayout());
        Point parentLoc = frmParent.getLocation();
        setLocation(parentLoc.x + 100, parentLoc.y + 100);
        
        m_btnRed = new JRadioButton("Rot");
        m_btnGreen = new JRadioButton("Grn");
        m_btnBlue = new JRadioButton("Blau");
        m_btnRed.addActionListener(this);
        m_btnGreen.addActionListener(this);
        m_btnBlue.addActionListener(this);
        
        final ButtonGroup bg = new ButtonGroup();
        bg.add(m_btnRed);
        bg.add(m_btnGreen);
        bg.add(m_btnBlue);
        
        JPanel panelRadios = new JPanel();
        panelRadios.setLayout(new GridLayout(3, 1, 0, 0));
        panelRadios.add(m_btnRed);
        panelRadios.add(m_btnGreen);
        panelRadios.add(m_btnBlue);
        
        JPanel panelButtons = new JPanel();
        JButton btnDo = new JButton("Anwenden");
        JButton btnUnDo = new JButton("Verwerfen");
        panelButtons.add(btnDo);
        panelButtons.add(btnUnDo);
        
        // Eventhandlers...
        btnDo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                frmParent.setImage();
            }
        });
        btnUnDo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                frmParent.rollBack();
                ButtonModel bm = bg.getSelection();
                bg.setSelected(bm, false);
            }
        });
        
        //Put everything together
        getContentPane().add(panelRadios, BorderLayout.CENTER);
        getContentPane().add(panelButtons, BorderLayout.SOUTH);
        pack();
        frmParent.addChild(this);
    }
    
    public void actionPerformed(ActionEvent e) {
        JRadioButton btnSource = (JRadioButton) e.getSource();
        
        if (btnSource == m_btnRed)
            m_frmParent.setColorChannel(1, 0, 0);
        else if (btnSource == m_btnGreen)
            m_frmParent.setColorChannel(0, 1, 0);
        else if (btnSource == m_btnBlue)
            m_frmParent.setColorChannel(0, 0, 1);
    }
}