import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.filechooser.FileFilter;
import java.io.*;
import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;
import java.util.*;
import java.awt.image.*;
import java.awt.image.renderable.*;
import javax.media.jai.*;
import javax.media.jai.operator.*;

public class HistogramPanel extends JPanel {
    private int[] m_nHistogramData;
    private int m_nMax;
    
    public HistogramPanel(int[] nHistogramData) {
        this.m_nHistogramData = nHistogramData;
        setPreferredSize(new Dimension(400, 200));
        
        m_nMax = -1;
        for (int i = 0; i < nHistogramData.length; i++) {
            if (m_nHistogramData[i] > m_nMax) {
                m_nMax = m_nHistogramData[i];
            }
        }
    }
    
    public void setData(int[] nHistogramData) {
        this.m_nHistogramData = nHistogramData;
        repaint();
    }
    
    public void paint(Graphics g) {
        int width = getSize().width - 2;
        int height = getSize().height - 2;
        
        g.setColor(Color.BLACK);
        g.fillRect(0, 0, getSize().width, getSize().height);
        g.setColor(Color.RED);
        g.drawRect(0, 0, getSize().width, getSize().height);
        g.setColor(Color.YELLOW);
        
        int length = m_nHistogramData.length;
        float slope_x = (float) width / (float) length;
        float slope_y = (float) height / (float) m_nMax;
        
        for (int i = 1; i < length; i++) {
            int x = (int) ((float) i * slope_x);
            int y = (int) ((float) m_nHistogramData[i] * slope_y);
            g.drawLine(x, height, x, height - y);
        }
    }
}